#include <stdlib.h>

class A
{
public:
    A(void)           // Constructeur.
    {
        return ;
    }

    ~A(void)          // Destructeur.
    {
        return ;
    }

    // L'oprateur new suivant utilise le placement.
    // Il reoit en paramtre le pointeur sur le bloc
    //  utiliser pour la requte d'allocation dynamique
    // de mmoire.
    static void *operator new (size_t taille, A *bloc)
    {
        return (void *) bloc;
    }

    // Oprateur new normal :
    static void *operator new(size_t taille)
    {
        // Implmentation.
        return malloc(taille);
    }

    static void operator delete(void *pBlock)
    {
	free(pBlock);
        return ;
    }
};

int main(void)
{
    A *pA=new A;      // Cration d'un objet de classe A.
                      // L'oprateur new global du C++ est utilis.
    pA->~A();         // Appel explicite du destructeur de A.
    A *pB=new(pA) A;  // Rutilisation de la mmoire de A.
    delete pB;        // Destruction de l'objet.
    return 0;
}

