#include <iostream>

using namespace std;

class erreur   // Premire exception possible, associe
               //  l'objet erreur.
{
public:
    int cause;  // Entier spcifiant la cause de l'exception.
                // Le constructeur. Il appelle le constructeur de cause.
    erreur(int c) : cause(c) {}
                // Le constructeur de copie. Il est utilis par le mcanisme
                // des exceptions :
    erreur(const erreur &source) : cause(source.cause) {}
};

class other {};   // Objet correspondant  toutes
                  // les autres exceptions.

int main(void)
{
    int i;            // Type de l'exception  gnrer.
    cout << "Tapez 0 pour gnrer une exception Erreur, "
            "1 pour une Entire :";
    cin >> i;         // On va gnrer une des trois exceptions
                      // possibles.
    cout << endl;
    try               // Bloc o les exceptions sont prises en charge.
    {
        switch (i)    // Selon le type d'exception dsire,
        {
        case 0:
            {
                erreur a(0);
                throw (a);   // on lance l'objet correspondant
                             // (ici, de classe erreur).
                             // Cela interrompt le code. break est
                             // donc inutile ici.
            }
        case 1:
            {
                int a=1;
                throw (a);   // Exception de type entier.
            }
        default:             // Si l'utilisateur n'a pas tap 0 ou 1,
            {
                other c;     // on cre l'objet c (type d'exception
                throw (c);   // other) et on le lance.
            }
        }
    }        // fin du bloc try. Les blocs catch suivent :
    catch (erreur &tmp) // Traitement de l'exception erreur &hellip;
    {                 // (avec rcupration de la cause).
        cout << "Erreur erreur ! (cause " << tmp.cause << ")" << endl;
    }
    catch (int tmp)   // Traitement de l'exception int&hellip;
    {
        cout << "Erreur int ! (cause " << tmp << ")" << endl;
    }
    catch (...)       // Traitement de toutes les autres
    {                 // exceptions (...).
                      // On ne peut pas rcuprer l'objet ici.
        cout << "Exception inattendue !" << endl;
    }
    return 0;
}

