struct A
{
    virtual void f(void)
    {
        return ;
    }
};
 
struct B : virtual public A
{
};
 
struct C : virtual public A, public B
{
};
 
struct D
{
    virtual void g(void)
    {
        return ;
    }
};

struct E : public B, public C, public D
{
};
 
int main(void)
{
    E e;        // e contient deux sous-objets de classe B
                // (mais un seul sous-objet de classe A).
                // Les sous-objets de classe C et D sont
                // frres.
    A *pA=&e;   // Drivation lgale : le sous-objet
                // de classe A est unique.
    // C *pC=(C *) pA;// Illgal : A est une classe de base
                      // virtuelle (erreur de compilation).
    C *pC=dynamic_cast<C *>(pA);  // Lgal. Transtypage
                                  // dynamique vertical.
    D *pD=dynamic_cast<D *>(pC);  // Lgal. Transtypage
                                  // dynamique horizontal.
    B *pB=dynamic_cast<B *>(pA);  // Lgal, mais chouera
                                  //  l'excution (ambigut).
    return 0 ;
}

